; #INDEX# =======================================================================================================================
; Nom .........: Translate
; Version .....: 1.0.1
; AutoIt Version : 3.3.6++
; Language ......: Franais
; Description ...: Fonction pour traduire du texte via Google Translate.
; Auteur(s) .....: aurel2108 (aurel2108 at gmail dot com)
;
; Version 1.0 : 22/07/2011
;			- Premire version
;
; Version 1.0.1 : 22/07/2011
; 			- Fin de l'utilisation de inet.au3 et _InetGetSource()
;			- Utilisation de InetRead() et BinaryToString()
; ===============================================================================================================================

;#include <inet.au3>
#include <Array.au3>
#Include <HTML.au3>
#Include <Timers.au3>

Dim Const $langs[32] = ['fr', 'en', 'de', 'es', 'it', 'pt', 'ca', 'hr', 'da', 'et', 'fi', 'gl', 'cy', 'hu', 'id', 'ga', 'is', 'lt','ms', 'mt', 'nl', 'no', 'pl', 'ro', 'sk', 'sl', 'sv', 'sw', 'tl', 'ts', 'tr', 'vi']

#cs
;Exemple (Traduit 'hello' en franais et l'affiche dans une MsgBox) :

$timer = _Timer_Init()
$translation = _Translate('hello', 'fr')
MsgBox(32, 'Translate', 'Temps d''excution : ' & _Timer_Diff($timer) / 1000 & 's' & @CRLF & 'Texte traduit : ' & $translation)
#ce

; #FUNCTION# ====================================================================================================================
; Nom...........: _Translate
; Description ...: Traduire un texte en utilisant Google Translate.
; Syntaxe.........: _Translate($text, $outputLang[, $inputLang])
; Paramtres ....: $text - Texte  traduire
;                  $outputLang  - Langue de sortie
;				   $inputLang - [optional] Langue d'entre (langue du texte)
; Valeurs de retour .: Succs - Retourne le texte traduit
;                 	   chec  - -1
; Auteur ........: aurel2108
; Remarques .......: Si le code source de Google Translate change, la fonction pourrait ne plus fonctionner, si c'est le cas, veuillez le signaler  l'auteur. ;)
;				   $inputLang et $outputLang doivent tre les "initiales" de la langue tel que 'fr' pour le franais, 'en' pour l'anglais, etc...
; Exemple .......: Oui (ci-dessus)
; ===============================================================================================================================

Dim $resultat[2]

func _Translate($text, $outputLang, $inputLang = 'auto')
	if _ArraySearch($langs, $outputLang) <> -1 Then
		if _ArraySearch($langs, $inputLang) == -1 Then
			$inputLang = 'auto'
		EndIf
		;$source = _INetGetSource("http://translate.google.com/translate_t?hl=&ie=UTF-8&text=" & $text & "&sl=" & $inputLang & "&tl=" & $outputLang)
		$source = InetRead("http://translate.google.com/translate_t?hl=&ie=UTF-8&text=" & $text & "&sl=" & $inputLang & "&tl=" & $outputLang)
		$source = BinaryToString($source)
		$resultat = StringRegExp($source,'onmouseout="this.style.backgroundColor=(.*?)>(.*?)</span>',2)
		return _HTMLDecode($resultat[2])
	Else
		return -1
	EndIf
EndFunc